<script setup lang="ts">
  import { computed } from 'vue';
  import { Product } from '@shopware-pwa/types';
  import { formatInlineProduct } from '~/helpers/formatInlineProduct';

  const props = defineProps<{
    data: Product;
  }>();

  const product = computed(() => props.data);
  const productId = computed(() => props.data.id);
  const loading = ref(false);
  const { quickViewModalController } = useQuickView();

  const { isGuide } = useUser();
  const { addToCart, loading: loadingAddToCart } = useAddToCart(product);
  const { toggleLike, isLiked, loading: loadingLike } = useLikeItem(productId);
  const { toggleBookmark, isBookmarked, loading: loadingBookmark } = useBookmarkItem(productId);
  const { isSelfService } = useAppointment();
  const { requestDynamicPage } = useDynamicPage();

  const itemData = computed(() => formatInlineProduct(product.value));

  const isMainProduct = computed(() => {
    return !!(
      product.value.parentId === null &&
      product.value.childCount &&
      product.value.childCount > 0
    );
  });

  const handleClick = () => {
    if (isSelfService.value) {
      requestDynamicPage({
        type: DynamicPageType.PRODUCT,
        productId: props.data.id,
      });
    } else {
      quickViewModalController.open(props.data.id);
    }
  };
</script>
<template>
  <SwInlineProductCard :data="itemData" :loading="loading" readonly @click="handleClick">
    <template #product-meta>
      <template v-if="isGuide">
        <SwBookmarkButton
          variant="action"
          class="!px-2"
          :is-bookmarked="isBookmarked"
          :loading="loadingBookmark"
          @click="toggleBookmark"
        />
      </template>
      <template v-else>
        <SwLikeButton
          class="!px-2"
          variant="action"
          :is-liked="isLiked"
          :loading="loadingLike"
          :show-label="false"
          @click="toggleLike"
        />
        <SwButton v-if="isMainProduct" variant="action" class="gap-1.5 !px-2" @click="handleClick">
          {{ $t('product.details') }}
        </SwButton>
        <SwButton
          v-else
          variant="action"
          class="gap-1.5 !px-2"
          :loading="loadingAddToCart"
          @click="addToCart"
        >
          <span class="i-sw-solid:shopping-cart text-sm" />
          {{ $t('product.addToCart') }}
        </SwButton>
      </template>
    </template>
    <template #product-price>
      <ProductPrice :product="product" layout="listing" :show-regulation-price="false" />
    </template>
  </SwInlineProductCard>
</template>
